
function mandelbrot(width, height, max_iter, r_min, r_max, i_min, i_max)
  
  local fr = (r_max - r_min) / width
  local fi = (i_max - i_min) / height
  
  local w, h
  local cr, ci, xr, xi, xr2, xi2
  local i
  local cnt
  
  gfx.set_size(width + 1, height + 1)
  gfx.clear()
  
  for h = 0, height do
    ci = fi * h + i_min
    
    for w = 0, width do
      cr = fr * w + r_min
      
      xr = 0
      xi = 0
      
      cnt = -1
      for i = 0, max_iter do
        
        xr2 = xr * xr
        xi2 = xi * xi
        
        if xr2 + xi2 > 4 then
          cnt = i
          break
        end
        
        xi = 2 * xr * xi + ci
        xr = xr2 - xi2 + cr
      end
      
      if cnt ~= -1 then
        -- gfx.set_color((cnt * 2) % 256, (cnt * 3) % 256, (cnt * 4) % 256)
        gfx.set_color((cnt / 4) % 256, (cnt / 2) % 256, (cnt / 1) % 256)
      else
        gfx.set_color("black")
      end
      
      gfx.draw_pnt(w, h)
    end
  end
  
end

-- mandelbrot(800, 600, 100, -2, 1, -1, 1)
-- mandelbrot(800, 600, 1000, -0.75, -0.73, 0.12, 0.14)
mandelbrot(800, 600, 1000, -0.75, -0.74, 0.12, 0.13)

