#!/bin/sh

set -e

change_header_file()
{
  cp $4 $4.bak
  sed -r -e 's/#define\s+PROGRAM_VERSION\s+"[0-9]+\.[0-9]+\.[0-9]+"/#define PROGRAM_VERSION "'$1'.'$2'.'$3'"/' $4.bak > $4
  rm $4.bak
}

change_make_dep_pkg()
{
  cp $4 $4.bak
  sed -r -e 's/fakeroot\s+dpkg\s+-b\s+tmp\s+lua-quick-try-out-[0-9]+\.[0-9]+\.[0-9]+-/fakeroot dpkg -b tmp lua-quick-try-out-'$1'.'$2'.'$3'-/' $4.bak > $4
  rm $4.bak
}

change_control()
{
  cp $4 $4.bak
  sed -r -e 's/Package:\s+lua-quick-try-out-[0-9]+\.[0-9]+\.[0-9]+/Package: lua-quick-try-out-'$1'.'$2'.'$3'/' \
         -e 's/Version:\s+[0-9]+\.[0-9]+\.[0-9]+/Version: '$1'.'$2'.'$3'/' $4.bak > $4
  rm $4.bak
}

change_iss()
{
  cp $4 $4.bak
  sed -r -e 's/AppVersion\s*=\s*[0-9]+\.[0-9]+\.[0-9]+/AppVersion='$1'.'$2'.'$3'/' \
         -e 's/AppVerName\s*=\s*Lua-Quick-Try-Out\s*[0-9]+\.[0-9]+\.[0-9]+/AppVerName=Lua-Quick-Try-Out '$1'.'$2'.'$3'/' \
         -e 's/OutputBaseFilename\s*=\s*Lua-Quick-Try-Out-[0-9]+\.[0-9]+\.[0-9]+_setup/OutputBaseFilename=Lua-Quick-Try-Out-'$1'.'$2'.'$3'_setup/' $4.bak > $4
  rm $4.bak
}

change_header_file $1 $2 $3 src/program_version.h

change_make_dep_pkg $1 $2 $3 InstallerLinux-32bit/make_debian_package.sh
change_make_dep_pkg $1 $2 $3 InstallerUbuntu-64bit/make_debian_package.sh
change_make_dep_pkg $1 $2 $3 InstallerLinux-64bit/make_debian_package.sh

change_control $1 $2 $3 InstallerLinux-32bit/control
change_control $1 $2 $3 InstallerUbuntu-64bit/control
change_control $1 $2 $3 InstallerLinux-64bit/control

change_iss $1 $2 $3 InstallerWindows-32bit/Lua-Quick-Try-Out_setup.iss
change_iss $1 $2 $3 InstallerWindows-64bit/Lua-Quick-Try-Out_setup.iss

