/*
  Copyright (C) 2012  Torsten Brischalle

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/
*/

#include "gfxview.h"

#include <iostream>
#include <QScrollBar>
#include <QMouseEvent>
#include <QWheelEvent>
#include <QLabel>
#include <QGraphicsPixmapItem>

using namespace std;

//-----------------------------------------------------------------------------

GfxView::GfxView(QWidget *parent) :
  QGraphicsView(parent)
{
}

//-----------------------------------------------------------------------------

void GfxView::wheelEvent(QWheelEvent* event)
{
  const double scaleFactor = 1.15;

  setTransformationAnchor(AnchorUnderMouse);

  if (event->delta() > 0)
  {
    // zoom in
    scale(scaleFactor, scaleFactor);
  }
  else
  {
    // zoom out
    scale(1.0 / scaleFactor, 1.0 / scaleFactor);
  }
}

//-----------------------------------------------------------------------------

